package Kimdaba; 
use strict;
use warnings;
use XML::Parser;

BEGIN {
    use Exporter   ();
    our ($VERSION, @ISA, @EXPORT, @EXPORT_OK, %EXPORT_TAGS);

    $VERSION     = 0.1;
    @ISA         = qw(Exporter);
    @EXPORT      = qw(&parsedb &printimage %imageoptions %imageattributes &getRootFolder &matchAllOptions &matchAnyOption);
    %EXPORT_TAGS = ( );     # eg: TAG => [ qw!name1 name2! ],

    # your exported package globals go here,
    # as well as any optionally exported functions
#@EXPORT_OK   = qw(%imageoptions %imageattributes);
}
our @EXPORT_OK;

# exported package globals go here
our %imageattributes;
our %imageoptions;

# non-exported package globals go here

# initialize package globals, first exported ones
%imageattributes=();
%imageoptions=();

# then the others (which are still accessible as $Some::Module::stuff)

# all file-scoped lexicals must be created before
# the functions below that use them.

# file-private lexicals go here
my $option="" ;
my $image="";	    # image element that we currently handle
my $optionname="";	    # currently handle option with name $option for image $image
my @values=();	    # currently found values

# here's a file-private function as a closure,
# callable as &$priv_func;  it cannot be prototyped.


# make all your functions, whether exported or not;
# remember to put something interesting in the {} stubs
sub matchAnyOption
{
    return @{ matchoptions( 0, @_) };
}
sub matchAllOptions
{
    return @{ matchoptions( 1, @_) };
}
sub matchoptions
{
    my ($matchall, %request)=@_;
    my @urlsfound=();
    my @checkoptions=keys %request;
URL:    for my $url (keys %imageoptions) 
    {
	my %options = %{ $imageoptions{$url} };
OPTION:	for my $option ( @checkoptions )		     # in (Keywords)	    
	{
	    unless (exists $options{$option} ) {
		if ( scalar @{ $request{$option} } == 0 ) {
		    next OPTION;
		} else {
		    next URL;
		}
	    }
			
								    # $matchall = 1
	    my @values_image   =@{ $options{$option} };		    # (Anne Helen)
	    my @values_searched=@{ $request{$option} };		    # (Jesper, Anne Helen)
	    for my $req (@values_searched)		    
	    {
		my $res = scalar grep { $_ eq $req } @values_image;
		if ( ($res == 0) && ($matchall) ) {
		    next URL;
		} elsif ( ($res!=0) && (!$matchall) ) {		    # if trouvé, here
		    next OPTION;
		}
	    }
	    if ($matchall) {
		next OPTION;# Found a value corresponding to each of the options
	    } else {
								    #here
		next URL;   # Never found a value corresponding to one of the options
	    }
	}
	push @urlsfound, $url;
	
    }
    return [ @urlsfound ];	
}
sub getRootFolder
{
    my ($folder)=@main::ARGV;
    if ($folder eq "") {
	$folder = "~/Images" ;
    }
    until ( (-d "$folder") && (-r "$folder/index.xml") )
    {
        print "In which folder are your pictures stored ?\n";
        chomp( $folder=<STDIN>);
    }
    return $folder;
}
sub parsedb ($)  
{
    my ($folder)=@_;
    my $p1 = new XML::Parser(
	Style => 'Subs'
    );
    die "Can not find KimDaBa's database"
	unless (-r "$folder/index.xml");
    $p1->parsefile( "$folder/index.xml");
}

sub printimage {
    my ($file)= @_;

    print "=== $file ===\n" ;
    print "Attributes : ";
    for my $attr ( keys %{ $imageattributes{$file} } )
    {
	print " $attr=>$imageattributes{$file}{$attr}  ";
    }
    print "\n";
	
    my %options = %{ $imageoptions{$file} };
    print "Options: \n" ;
    for my $key ( sort keys %options ) 
    {
	print "\t$key ==> ", join('; ', @{ $options{$key} } ) , "\n";
    }
    print "\n";
}




# this one isn't exported, but could be called!
sub image {
    my ( $p, $el, %attrs ) = @_ ;
    $image = $attrs{"file"} ;
    $imageattributes{$image} = \%attrs;
}
sub image_ {
    my ( $p, $el ) = @_;
    $image = "";
}
	
sub options {
    my ( $p, $el, %attrs ) = @_ ;
    return  if ($image eq "") ;	# We are in KimDaBa>config>SearchInfo>Options>Option
				# or in KimDaBa>Options
    $imageoptions{$image} = {} ;
}    
sub option {
    my ( $p, $el, %attrs ) = @_ ;
    return  if ($image eq "") ;	# We are in KimDaBa>config>SearchInfo>Options>Option
				# or in KimDaBa>Options
    $optionname=$attrs{"name"};	
    @values=();
}
sub option_ {
    my ( $p, $el ) = @_;
    if ($image eq "") {
	$optionname="";
	return;
    }
    $imageoptions{$image}->{$optionname} = [ @values ];
    $optionname="";
}

sub value {
    my ( $p, $el, %attrs ) = @_ ;
    return if ( $optionname eq "" ) ;
    push @values, $attrs{"value"};
}




END { }       # module clean-up code here (global destructor)





## YOUR CODE GOES HERE





1;  # don't forget to return a true value from the file

